<mat-sidenav-container autosize class="maarch-container">
    <ng-template #adminMenuTemplate>
        <mat-nav-list *ngIf="!creationMode && !loading">
            <h3 mat-subheader>{{lang.actions}}</h3>
            <a mat-list-item *ngIf="user.status != 'ABS'" (click)="activateAbsence()">
                <mat-icon color="warn" mat-list-icon class="fa fa-plane"></mat-icon>
                <p mat-line>
                    {{lang.activateAbsence}}
                </p>
            </a>
            <a mat-list-item *ngIf="user.status == 'ABS'" (click)="desactivateAbsence()">
                <mat-icon color="accent" mat-list-icon class="fa fa-check"></mat-icon>
                <p mat-line>
                    {{lang.desactivateAbsence}}
                </p>
            </a>
            <a mat-list-item *ngIf="user.canSendActivationNotification" (click)="resendActivationNotification()">
                <mat-icon color="primary" mat-list-icon class="fa fa-paper-plane"></mat-icon>
                <p mat-line>
                    {{lang.sendActivationNotification}}
                </p>
            </a>
            <a *ngIf="user.canModifyPassword" mat-list-item (click)="changePasswd();">
                <mat-icon color="primary" mat-list-icon class="fa fa-key"></mat-icon>
                <p mat-line>
                    {{lang.changePassword}}
                </p>
            </a>
            <a mat-list-item *ngIf="user.canCreateMaarchParapheurUser || maarchParapheurLink.login === ''"
                (click)="linkMaarchParapheurAccount()" title="{{lang.createUserInMaarchParapheur}}">
                <mat-icon color="primary" mat-list-icon class="fa fa-link"></mat-icon>
                <p mat-line>
                    {{lang.linkAccount}}
                </p>
                <p mat-line *ngIf="!maarchParapheurConnectionStatus" style="font-size:11px;color:red">
                    {{lang.maarchParapheurLinkbroken}}
                </p>
            </a>
        </mat-nav-list>
        <mat-divider></mat-divider>
        <mat-list *ngIf="maarchParapheurLink.login !== ''">
            <h3 mat-subheader>Compte Maarch Parapheur</h3>
            <mat-list-item>
                <mat-icon class="avatarAccount" color="primary" mat-list-icon
                    [style.background-image]="'url('+maarchParapheurLink.picture+')'"></mat-icon>
                <p mat-line class="accountInfo">
                    <span>
                        {{maarchParapheurLink.login}}
                    </span>
                    <button mat-icon-button color="warn" (click)="unlinkMaarchParapheurAccount()"
                        title="{{lang.unlinkAccount}}">
                        <mat-icon class="fas fa-unlink"></mat-icon>
                    </button>
                </p>
            </mat-list-item>
        </mat-list>
    </ng-template>
    <mat-sidenav-content>
        <div class="bg-head">
            <div class="bg-head-title" [class.customContainerRight]="appService.getViewMode()">
                <div class="bg-head-title-label">
                    <header-left></header-left>
                </div>
                <div class="bg-head-title-tool">
                    <header-right></header-right>
                </div>
            </div>
            <div class="bg-head-content" [class.fullContainer]="appService.getViewMode()">
            </div>
        </div>
        <div class="container" [class.fullContainer]="appService.getViewMode()">
            <div class="container-content">
                <div *ngIf="loading" style="display:flex;height:100%;">
                    <mat-spinner style="margin:auto;"></mat-spinner>
                </div>
                <mat-card *ngIf="!loading" class="card-app-content">
                    <mat-tab-group [(selectedIndex)]="selectedTabIndex" (selectedTabChange)="initService()">
                        <mat-tab label="{{lang.informations}}">
                            <div *ngIf="showPassword" style="margin-bottom: 5%">
                                <form [formGroup]="firstFormGroup">
                                    <div class="form-group">
                                        <mat-form-field style="padding:10px;">
                                            <input matInput placeholder="{{lang.typeCurrentPassword}}"
                                                formControlName="currentPasswordCtrl" required
                                                [type]="hidePassword ? 'password' : 'text'">
                                            <mat-icon matSuffix (click)="hidePassword = !hidePassword" class="fa fa-2x"
                                                [ngClass]="[hidePassword ? 'fa-eye-slash' : 'fa-eye']"></mat-icon>
                                            <mat-error
                                                *ngIf="firstFormGroup.controls['currentPasswordCtrl'].hasError('required')">
                                                {{lang.requiredField}}</mat-error>
                                        </mat-form-field>
                                    </div>
                                    <div class="form-group">
                                        <div style="text-align:center;color: rgba(0,0,0,0.54);font-size: 75%;">
                                            {{this.ruleText}}</div>
                                        <div class="col-sm-6" style="padding-left:0px;padding-right: 0px;">
                                            <mat-form-field style="padding:10px;">
                                                <input matInput #inputPasswd placeholder="{{lang.typeNewPassword}}"
                                                    formControlName="newPasswordCtrl" required
                                                    [type]="hidePassword ? 'password' : 'text'">
                                                <mat-icon matSuffix (click)="hidePassword = !hidePassword"
                                                    class="fa fa-2x"
                                                    [ngClass]="[hidePassword ? 'fa-eye-slash' : 'fa-eye']"></mat-icon>
                                                <mat-hint *ngIf="validPassword">
                                                    <i color="accent" class="fa fa-check"></i>
                                                    <span color="accent">{{lang.passwordValid}}</span>
                                                </mat-hint>
                                                <mat-error>{{getErrorMessage()}}</mat-error>
                                            </mat-form-field>
                                        </div>
                                        <div class="col-sm-6" style="padding-left:0px;padding-right:0px;">
                                            <mat-form-field style="padding:10px;">
                                                <input matInput #inputPasswd2 placeholder="{{lang.retypeNewPassword}}"
                                                    required [type]="hidePassword ? 'password' : 'text'"
                                                    formControlName="retypePasswordCtrl">
                                                <mat-icon matSuffix (click)="hidePassword = !hidePassword"
                                                    class="fa fa-2x"
                                                    [ngClass]="[hidePassword ? 'fa-eye-slash' : 'fa-eye']"></mat-icon>
                                                <mat-hint
                                                    *ngIf="!firstFormGroup.controls['retypePasswordCtrl'].hasError('mismatch') && firstFormGroup.controls['retypePasswordCtrl'].value != ''">
                                                    <i color="accent" class="fa fa-check"></i>
                                                    <span color="accent">{{lang.passwordMatch}}</span>
                                                </mat-hint>
                                                <mat-error>{{lang.passwordNotMatch}} !</mat-error>
                                            </mat-form-field>
                                        </div>
                                    </div>
                                    <div *ngIf="passwordRules.renewal.enabled || passwordRules.historyLastUse.enabled"
                                        class="form-group">
                                        <div class="col-sm-12" style="padding-left:0px;padding-right:0px;">
                                            <div class="alert alert-warning" role="alert" [innerHTML]="otherRuleText"
                                                style="text-align:center;"></div>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <div style="text-align:center;">
                                            <button mat-raised-button color="primary" type="button"
                                                (click)="updatePassword()"
                                                [disabled]="!firstFormGroup.valid">{{lang.update}}</button>
                                            <button mat-raised-button color="default" type="button"
                                                (click)="showPassword=false">{{lang.cancel}}</button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div *ngIf="user.status == 'ABS' && !showPassword" class="text-warning"
                                style="position: absolute;opacity: 0.25;font-size: 120px;transform: rotate(324deg);-webkit-transform: rotate(324deg);margin-left: 35%;margin-top: 90px;">
                                {{user.status}}</div>
                            <form class="form-horizontal" (ngSubmit)="onSubmit()" #profileForm="ngForm"
                                *ngIf="!showPassword">
                                <div class="form-group">
                                    <div class="col-sm-12">
                                        <div class="pull-left">
                                            <div class="avatar" style="font-size:90px;text-align:center;">
                                                <i class="fa fa-user" style="font-size:90px;padding-top:5px;"></i>
                                            </div>
                                        </div>
                                        <div class="input-group">
                                            <mat-form-field>
                                                <input matInput *ngIf="creationMode" type="text" title="{{lang.id}}"
                                                    name="user_id" [(ngModel)]="user.userId" placeholder="{{lang.id}}"
                                                    pattern="^[\w.@-]*$" required (keyup)="setLowerUserId()" maxlength="128">
                                                <input matInput *ngIf="!creationMode" type="text" title="{{lang.id}}"
                                                    value="{{user.user_id}}" placeholder="{{lang.id}}" disabled>
                                            </mat-form-field>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="col-sm-5" style="font-weight:bold;">
                                        <mat-form-field>
                                            <input matInput type="text" id="lastname" name="lastname" maxlength="255"
                                                title="{{lang.lastname}}" placeholder="{{lang.lastname}}"
                                                [(ngModel)]="user.lastname" required>
                                        </mat-form-field>
                                    </div>
                                    <div class="col-sm-5" style="font-weight:bold;">
                                        <mat-form-field>
                                            <input matInput type="text" id="firstname" name="firstname" maxlength="255"
                                                title="{{lang.firstname}}" placeholder="{{lang.firstname}}"
                                                [(ngModel)]="user.firstname" required>
                                        </mat-form-field>
                                    </div>
                                    <div class="col-sm-2" style="font-style:italic;">
                                        <mat-form-field>
                                            <input matInput type="text" id="initials" name="initials" maxlength="32"
                                                title="{{lang.initials}}" placeholder="{{lang.initials}}"
                                                [(ngModel)]="user.initials">
                                        </mat-form-field>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="col-sm-12">
                                        <mat-form-field>
                                            <input matInput type="tel" id="phone" name="phone" maxlength="32"
                                                title="{{lang.phoneNumber}}" placeholder="{{lang.phoneNumber}}"
                                                [(ngModel)]="user.phone" pattern="\+?((|\ |\.|\(|\)|\-)?(\d)*)*\d$"
                                                [disabled]="(creationMode && !canManagePersonalDatas) || (!creationMode && (!canManagePersonalDatas || !canViewPersonalDatas))">
                                        </mat-form-field>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="col-sm-12">
                                        <mat-form-field>
                                            <input matInput type="email" id="mail" name="mail" title="{{lang.email}}"
                                                placeholder="{{lang.email}}" [(ngModel)]="user.mail" maxlength="255"
                                                pattern="(^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$)" required>
                                        </mat-form-field>
                                    </div>
                                </div>
                                <mat-accordion>
                                    <mat-expansion-panel>
                                        <mat-expansion-panel-header>
                                            <mat-panel-title style="color: rgba(0,0,0,0.54);">
                                                {{lang.otherInformations}}
                                            </mat-panel-title>
                                        </mat-expansion-panel-header>
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <mat-checkbox color="primary"
                                                    matTooltip="{{lang.webserviceAccountDesc}}" name="loginmode"
                                                    (change)="setUserModeLogin($event)"
                                                    [checked]="user.loginmode == 'restMode'">
                                                    {{lang.webserviceAccount}}
                                                </mat-checkbox>
                                            </div>
                                        </div>
                                    </mat-expansion-panel>
                                </mat-accordion>
                                <div class="form-group" style="margin-top: 10px;">
                                    <div style="text-align:center;">
                                        <button mat-raised-button color="primary" *ngIf="creationMode" type="submit"
                                            [disabled]="!profileForm.form.valid">{{lang.save}}</button>
                                        <button mat-raised-button color="primary" *ngIf="!creationMode" type="submit"
                                            [disabled]="!profileForm.form.valid">{{lang.update}}</button>
                                    </div>
                                </div>
                            </form>
                        </mat-tab>
                        <mat-tab *ngIf="!creationMode" label="{{lang.groups}}">
                            <mat-nav-list>
                                <mat-list-item *ngFor="let group of user.allGroups" disableRipple="true">
                                    <mat-slide-toggle id="{{group.group_id}}" color="primary"
                                        [checked]="group.checked == true" [disabled]="!group.enabled"
                                        (change)="toggleGroup(group)">
                                        {{group.group_desc}}</mat-slide-toggle>
                                </mat-list-item>
                            </mat-nav-list>
                        </mat-tab>
                        <mat-tab *ngIf="!creationMode" label="{{lang.entities}}">
                            <mat-form-field>
                                <input matInput id="jstree_search" type="text" placeholder="{{lang.searchEntities}}">
                                <mat-hint>{{lang.linkEntityToUserInfo}}</mat-hint>
                            </mat-form-field>
                            <div id="jstree"></div>
                        </mat-tab>
                        <mat-tab *ngIf="!creationMode" label="{{lang.baskets}}">
                            <div class="col-sm-6" style="overflow:hidden;">
                                <mat-list>
                                    <mat-list-item>
                                        <mat-icon mat-list-icon color="primary">
                                            <mat-checkbox color="primary"
                                                (change)="$event ? masterToggleBaskets($event) : null"
                                                [checked]="selectionBaskets.hasValue()" matTooltip="{{lang.selectAll}}">
                                            </mat-checkbox>
                                        </mat-icon>
                                        <p mat-line *ngIf="!selectionBaskets.hasValue()"
                                            style="opacity: 0.5;font-style: italic;font-size: 80%;margin-top:10px;">
                                            {{lang.selectAll}}
                                        </p>
                                        <p mat-line *ngIf="selectionBaskets.hasValue()" style="margin-top:10px;">
                                            <button [matMenuTriggerFor]="menu" mat-icon-button
                                                matTooltip="{{ lang.redirectBaskets }}">
                                                <mat-icon class="fa fa-reply"></mat-icon>
                                                <mat-divider [vertical]="true" class="vertical-divider"></mat-divider>
                                            </button>
                                            <button color="warn" mat-icon-button matTooltip="{{lang.disableBasket}}"
                                                (click)="toggleBasket(false)">
                                                <mat-icon class="fa fa-ban"></mat-icon>
                                            </button>
                                            <button color="accent" mat-icon-button matTooltip="{{lang.enableBasket}}"
                                                (click)="toggleBasket(true)">
                                                <mat-icon class="fa fa-check"></mat-icon>
                                            </button>
                                            <mat-menu #menu="matMenu" style="width:200px !important;">
                                                <plugin-autocomplete [labelPlaceholder]="lang.redirectBaskets"
                                                    [routeDatas]="['/rest/autocomplete/users']"
                                                    [targetSearchKey]="'idToDisplay'"
                                                    [subInfoKey]="'descriptionToDisplay'"
                                                    (triggerEvent)="addBasketRedirection($event)" appearance="outline">
                                                </plugin-autocomplete>
                                            </mat-menu>
                                        </p>
                                    </mat-list-item>
                                    <mat-divider></mat-divider>
                                    <ng-container *ngFor="let basket of user.baskets;let i = index">
                                        <mat-list-item *ngIf="basket.userToDisplay == null" style="cursor: pointer;">
                                            <mat-icon mat-list-icon color="primary" *ngIf="basket.enabled">
                                                <mat-checkbox (click)="$event.stopPropagation()"
                                                    (change)="$event ? selectionBaskets.toggle(basket) : null"
                                                    [checked]="selectionBaskets.isSelected(basket)" color="primary">
                                                </mat-checkbox>
                                            </mat-icon>
                                            <h4 mat-line color="primary" style="display: flex;align-items: center;">
                                                <span (click)="selectionBaskets.toggle(basket);"
                                                    matTooltip="{{basket.basket_name}} [{{basket.group_desc}}]"
                                                    [ngStyle]="{'opacity': basket.allowed ? '1' : '0.5'}"
                                                    style="flex: 2;overflow: hidden;text-overflow: ellipsis;">
                                                    {{basket.basket_name}}
                                                    <span class="label label-primary"
                                                        style="font-weight:normal">{{basket.group_desc}}</span>
                                                </span>
                                            </h4>
                                        </mat-list-item>
                                    </ng-container>
                                </mat-list>
                            </div>
                            <div class="col-sm-6" style="overflow:hidden;">
                                <mat-tab-group>
                                    <mat-tab label="{{lang.basketsRedirected}}">
                                        <mat-list>
                                            <ng-container *ngFor="let basket of user.redirectedBaskets;let i = index">
                                                <mat-list-item>
                                                    <mat-icon mat-list-icon color="primary" style="margin-top:-60px;"
                                                        class="fa fa-paper-plane">
                                                    </mat-icon>
                                                    <h4 mat-line color="primary">{{basket.basket_name}}
                                                        <span class="label label-primary"
                                                            style="font-weight:normal">{{basket.group_desc}}</span>
                                                    </h4>
                                                    <p mat-line>
                                                        <mat-form-field>
                                                            <input type="text" color="warn" matInput disabled
                                                                value="{{lang.redirectedTo}} {{basket.userToDisplay}}">
                                                            <button mat-button color="warn" matSuffix mat-icon-button
                                                                aria-label="Clear"
                                                                (click)="delBasketRedirection(basket,i)"
                                                                matTooltip="{{lang.deleteRedirection}}">
                                                                <mat-icon color="warn" class="fa fa-times text-danger">
                                                                </mat-icon>
                                                            </button>
                                                        </mat-form-field>
                                                    </p>
                                                </mat-list-item>
                                            </ng-container>
                                        </mat-list>
                                    </mat-tab>
                                </mat-tab-group>

                                <mat-tab-group>
                                    <mat-tab label="{{lang.basketsAssigned}}">
                                        <mat-list>
                                            <ng-container *ngFor="let basket of user.assignedBaskets;let i = index">
                                                <mat-list-item>
                                                    <mat-icon mat-list-icon color="primary" style="margin-top:-60px;"
                                                        class="fa fa-reply">
                                                    </mat-icon>
                                                    <h4 mat-line color="primary">{{basket.basket_name}}
                                                        <span class="label label-primary"
                                                            style="font-weight:normal">{{basket.group_desc}}</span>
                                                    </h4>
                                                    <p mat-line>
                                                        <plugin-autocomplete *ngIf="basket.userToDisplay == null"
                                                            [labelPlaceholder]="lang.redirectBaskets"
                                                            [routeDatas]="['/rest/autocomplete/users']"
                                                            [targetSearchKey]="'idToDisplay'"
                                                            [subInfoKey]="'descriptionToDisplay'"
                                                            (triggerEvent)="reassignBasketRedirection($event,basket,i)"
                                                            appearance="outline"></plugin-autocomplete>
                                                        <mat-form-field>
                                                            <input type="text" color="warn" matInput disabled
                                                                value="{{lang.assignBy}} {{basket.userToDisplay}}">
                                                            <button mat-button color="warn" matSuffix mat-icon-button
                                                                aria-label="Clear" (click)="basket.userToDisplay=null"
                                                                matTooltip="{{lang.reassign}}">
                                                                <mat-icon color="primary" class="fa fa-edit"></mat-icon>
                                                            </button>
                                                            <button mat-button color="warn" matSuffix mat-icon-button
                                                                aria-label="Clear"
                                                                (click)="delBasketAssignRedirection(basket,i)"
                                                                matTooltip="{{lang.deleteAssignation}}">
                                                                <mat-icon color="warn" class="fa fa-times text-danger">
                                                                </mat-icon>
                                                            </button>
                                                        </mat-form-field>
                                                    </p>
                                                </mat-list-item>
                                            </ng-container>
                                        </mat-list>
                                    </mat-tab>
                                </mat-tab-group>
                            </div>
                        </mat-tab>
                        <mat-tab *ngIf="!creationMode" label="{{lang.signatures}}" [disabled]="!canViewPersonalDatas">
                            <div *ngIf="canManagePersonalDatas" dnd-droppable matTooltip="{{lang.uploadSignFileInfo}}"
                                (click)="clickOnUploader('uploadSignFile')" [class.dndFileHighlighted]="highlightMe"
                                (dragover)="highlightMe=true" (dragleave)="highlightMe=false"
                                (onDropSuccess)="test($event);highlightMe=false;" class="dndFile">
                                {{lang.uploadSignFile}}
                            </div>
                            <div style="display: flex;align-items: flex-start;">
                                <div style="flex:1;">
                                    <div class="col-md-3 col-sm-6 col-xm-12"
                                        *ngFor="let signature of user.signatures; let i = index">
                                        <mat-card style="margin-bottom:10px;overflow:hidden;">
                                            <mat-card-content style="text-align:center;">
                                                <mat-form-field floatLabel="never">
                                                    <input matInput type="text" [(ngModel)]="signature.signature_label"
                                                        name="selectedSignatureLabel" placeholder="{{lang.label}}"
                                                        (change)="updateSignature(i)"
                                                        [disabled]="!canManagePersonalDatas">
                                                    <button mat-button matSuffix mat-icon-button
                                                        (click)="deleteSignature(signature)" color="warn"
                                                        matTooltip="{{lang.delete}}"
                                                        [disabled]="!canManagePersonalDatas">
                                                        <mat-icon class="fa fa-times"></mat-icon>
                                                    </button>
                                                </mat-form-field>
                                                <img src="../../rest/users/{{user.id}}/signatures/{{signature.id}}/content"
                                                    alt="Signature" style="width:auto;height:60px;">
                                            </mat-card-content>
                                        </mat-card>
                                    </div>
                                </div>
                                <div>
                                    <button *ngIf="user.signatures.length > 0 && canManagePersonalDatas" mat-icon-button
                                        color="primary" (click)="syncMP()"
                                        matTooltip="{{lang.syncSignsToMaarchParapheur}}"
                                        [disabled]="!user.external_id.maarchParapheur || loadingSign">
                                        <mat-icon class="fa fa-sync-alt fa-2x" [class.fa-spin]="loadingSign"></mat-icon>
                                    </button>
                                </div>
                            </div>
                            <form (ngSubmit)="submitSignature()" #signatureForm="ngForm" style="display:none;">
                                <div class="col-md-11">
                                    <input type="text" [(ngModel)]="signatureModel.label" id="signLabel" name="label"
                                        placeholder="{{lang.label}}" class="form-control" required>
                                    <div class="form-inline hide">
                                        <div class="form-group">
                                            <input type="file" name="files[]" id="uploadSignFile"
                                                (change)="uploadSignatureTrigger($event)" accept="image/*">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-1" style="margin-bottom:5px;">
                                    <button class="form-control btn btn-sm btn-success" type="submit"
                                        [disabled]="!signatureForm.form.valid || !signatureModel.size">
                                        <i class="fa fa-plus"></i>
                                    </button>
                                </div>
                                <div [ngClass]="[signatureModel.size != '' ? 'col-md-10' : 'col-md-12']">
                                    <div class="upload-drop-zone" (click)="clickOnUploader('uploadSignFile')"
                                        style="cursor:pointer">
                                        {{lang.clickOn}}
                                        <i class="fa fa-upload fa-2x"></i> (
                                        < 2MB ) </div> </div> <div class="col-md-2" *ngIf="signatureModel.size">
                                            <img id="signaturePreview" src="{{signatureModel.base64ForJs}}"
                                                alt="Invalid image" style="width: 100%;">
                                    </div>
                            </form>
                        </mat-tab>
                        <mat-tab *ngIf="!creationMode" label="{{lang.history}}">
                            <div class="col-md-12">
                                <div>
                                    <div class="row">
                                        <div class="col-md-6 col-xs-6">
                                            <mat-form-field>
                                                <input matInput (keyup)="applyFilter($event.target.value)"
                                                    placeholder="{{lang.filterBy}}">
                                            </mat-form-field>
                                        </div>
                                        <div class="col-md-6 col-xs-6">
                                            <mat-paginator #paginator [length]="100" [hidePageSize]="true"
                                                [pageSize]="10">
                                            </mat-paginator>
                                        </div>
                                    </div>
                                    <mat-table #table [dataSource]="dataSource" matSort matSortActive="event_date"
                                        matSortDirection="desc">
                                        <ng-container matColumnDef="event_date">
                                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:1;">
                                                {{lang.date}}
                                            </mat-header-cell>
                                            <mat-cell *matCellDef="let element" style="flex:1;">
                                                {{element.event_date | date : "dd/MM/y HH:mm"}}</mat-cell>
                                        </ng-container>
                                        <ng-container matColumnDef="record_id">
                                            <mat-header-cell *matHeaderCellDef style="flex:1;">{{lang.technicalId}}</mat-header-cell>
                                            <mat-cell *matCellDef="let element" style="flex:1;">{{element.record_id}}</mat-cell>
                                        </ng-container>
                                        <ng-container matColumnDef="info">
                                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:2;">
                                                {{lang.description}}</mat-header-cell>
                                            <mat-cell *matCellDef="let element" style="flex:2;"> {{element.info}}
                                            </mat-cell>
                                        </ng-container>
                                        <ng-container matColumnDef="remote_ip">
                                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:1;">
                                                {{lang.ip}}
                                            </mat-header-cell>
                                            <mat-cell *matCellDef="let element" style="flex:1;"> {{element.remote_ip}}
                                            </mat-cell>
                                        </ng-container>
                                        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
                                        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
                                    </mat-table>
                                    <div class="row">
                                        <div class="col-md-3 pull-right" style="padding-top:10px;">
                                            <mat-form-field>
                                                <input matInput [(ngModel)]="minDate" [matDatepicker]="picker"
                                                    placeholder="{{lang.since}}" disabled>
                                                <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
                                                <mat-datepicker #picker startView="month" [startAt]="minDate">
                                                </mat-datepicker>
                                            </mat-form-field>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </mat-tab>
                    </mat-tab-group>
                </mat-card>
            </div>
        </div>
    </mat-sidenav-content>

    <mat-sidenav #snav2 [mode]="appService.getViewMode() ? 'over' : 'side'" [fixedInViewport]="appService.getViewMode()"
        fixedTopGap="56" position='end' [opened]="appService.getViewMode() || creationMode ? false : true"
        style="overflow-x:hidden;max-width:500px;">
        <mat-list>
            <h3 mat-subheader>{{lang.groups}}</h3>
            <mat-list-item *ngFor="let userGroup of user.groups">
                <mat-icon color="primary" mat-list-icon class="fa fa-users"></mat-icon>
                <h4 mat-line>{{userGroup.group_desc}}</h4>
                <p mat-line>
                    <mat-form-field style="font-size:10px;">
                        <input matInput type="text" id="role" name="role" title="{{lang.role}}"
                            placeholder="{{lang.role}}" [(ngModel)]="userGroup.role" (change)="updateGroup(userGroup)">
                        <mat-hint matTooltip="{{lang.perimeter}}">{{userGroup.maarch_comment}}</mat-hint>
                    </mat-form-field>
                </p>
            </mat-list-item>
            <mat-divider></mat-divider>
            <h3 mat-subheader>{{lang.entities}}</h3>
            <mat-list-item *ngFor="let userEntity of user.entities">
                <mat-icon color="primary" *ngIf="userEntity.primary_entity == 'Y'" mat-list-icon class="fa fa-sitemap">
                </mat-icon>
                <mat-icon color="primary" *ngIf="userEntity.primary_entity != 'Y'" mat-list-icon class="fa fa-sitemap"
                    style="position:relative;">
                    <button mat-icon-button
                        style="cursor:pointer;position: absolute;right: -20px;top: -20px;font-size:10px;"
                        (click)="updatePrimaryEntity(userEntity)" matTooltip="{{lang.entityTooglePrimary}}">
                        <mat-icon class="fa fa-arrow-up"></mat-icon>
                    </button>
                </mat-icon>
                <h4 mat-line [ngStyle]="{'font-weight': userEntity.primary_entity == 'Y' ? 'bold' : 'normal'}"
                    matTooltip="{{userEntity.entity_label}}">
                    {{userEntity.entity_label}}
                    <span *ngIf="userEntity.primary_entity == 'Y'" class="label label-primary"
                        style="font-weight:normal">{{lang.primary}}</span>
                </h4>
                <p mat-line>
                    <mat-form-field style="font-size:10px;">
                        <input matInput type="text" id="role" name="role" title="{{lang.role}}"
                            placeholder="{{lang.role}}" [(ngModel)]="userEntity.user_role"
                            (change)="updateEntity(userEntity)">
                    </mat-form-field>
                </p>
            </mat-list-item>
        </mat-list>
    </mat-sidenav>

</mat-sidenav-container>
